// Code generated by mockery v2.38.0. DO NOT EDIT.

package brand

import (
	context "context"
	entities "go-code/pkg/entities"

	gorm "gorm.io/gorm"

	gormquery "go-code/pkg/functions/gormquery"

	mock "github.com/stretchr/testify/mock"
)

// MockRepository is an autogenerated mock type for the Repository type
type MockRepository struct {
	mock.Mock
}

type MockRepository_Expecter struct {
	mock *mock.Mock
}

func (_m *MockRepository) EXPECT() *MockRepository_Expecter {
	return &MockRepository_Expecter{mock: &_m.Mock}
}

// BeginTransaction provides a mock function with given fields:
func (_m *MockRepository) BeginTransaction() *gorm.DB {
	ret := _m.Called()

	if len(ret) == 0 {
		panic("no return value specified for BeginTransaction")
	}

	var r0 *gorm.DB
	if rf, ok := ret.Get(0).(func() *gorm.DB); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*gorm.DB)
		}
	}

	return r0
}

// MockRepository_BeginTransaction_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'BeginTransaction'
type MockRepository_BeginTransaction_Call struct {
	*mock.Call
}

// BeginTransaction is a helper method to define mock.On call
func (_e *MockRepository_Expecter) BeginTransaction() *MockRepository_BeginTransaction_Call {
	return &MockRepository_BeginTransaction_Call{Call: _e.mock.On("BeginTransaction")}
}

func (_c *MockRepository_BeginTransaction_Call) Run(run func()) *MockRepository_BeginTransaction_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run()
	})
	return _c
}

func (_c *MockRepository_BeginTransaction_Call) Return(_a0 *gorm.DB) *MockRepository_BeginTransaction_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_BeginTransaction_Call) RunAndReturn(run func() *gorm.DB) *MockRepository_BeginTransaction_Call {
	_c.Call.Return(run)
	return _c
}

// Count provides a mock function with given fields: ctx, queries
func (_m *MockRepository) Count(ctx context.Context, queries ...gormquery.Query) (int64, error) {
	_va := make([]interface{}, len(queries))
	for _i := range queries {
		_va[_i] = queries[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for Count")
	}

	var r0 int64
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, ...gormquery.Query) (int64, error)); ok {
		return rf(ctx, queries...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, ...gormquery.Query) int64); ok {
		r0 = rf(ctx, queries...)
	} else {
		r0 = ret.Get(0).(int64)
	}

	if rf, ok := ret.Get(1).(func(context.Context, ...gormquery.Query) error); ok {
		r1 = rf(ctx, queries...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_Count_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Count'
type MockRepository_Count_Call struct {
	*mock.Call
}

// Count is a helper method to define mock.On call
//   - ctx context.Context
//   - queries ...gormquery.Query
func (_e *MockRepository_Expecter) Count(ctx interface{}, queries ...interface{}) *MockRepository_Count_Call {
	return &MockRepository_Count_Call{Call: _e.mock.On("Count",
		append([]interface{}{ctx}, queries...)...)}
}

func (_c *MockRepository_Count_Call) Run(run func(ctx context.Context, queries ...gormquery.Query)) *MockRepository_Count_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]gormquery.Query, len(args)-1)
		for i, a := range args[1:] {
			if a != nil {
				variadicArgs[i] = a.(gormquery.Query)
			}
		}
		run(args[0].(context.Context), variadicArgs...)
	})
	return _c
}

func (_c *MockRepository_Count_Call) Return(_a0 int64, _a1 error) *MockRepository_Count_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_Count_Call) RunAndReturn(run func(context.Context, ...gormquery.Query) (int64, error)) *MockRepository_Count_Call {
	_c.Call.Return(run)
	return _c
}

// Create provides a mock function with given fields: ctx, data
func (_m *MockRepository) Create(ctx context.Context, data *entities.Brand) error {
	ret := _m.Called(ctx, data)

	if len(ret) == 0 {
		panic("no return value specified for Create")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *entities.Brand) error); ok {
		r0 = rf(ctx, data)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockRepository_Create_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Create'
type MockRepository_Create_Call struct {
	*mock.Call
}

// Create is a helper method to define mock.On call
//   - ctx context.Context
//   - data *entities.Brand
func (_e *MockRepository_Expecter) Create(ctx interface{}, data interface{}) *MockRepository_Create_Call {
	return &MockRepository_Create_Call{Call: _e.mock.On("Create", ctx, data)}
}

func (_c *MockRepository_Create_Call) Run(run func(ctx context.Context, data *entities.Brand)) *MockRepository_Create_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*entities.Brand))
	})
	return _c
}

func (_c *MockRepository_Create_Call) Return(_a0 error) *MockRepository_Create_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_Create_Call) RunAndReturn(run func(context.Context, *entities.Brand) error) *MockRepository_Create_Call {
	_c.Call.Return(run)
	return _c
}

// Delete provides a mock function with given fields: ctx, queries
func (_m *MockRepository) Delete(ctx context.Context, queries ...gormquery.Query) error {
	_va := make([]interface{}, len(queries))
	for _i := range queries {
		_va[_i] = queries[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for Delete")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, ...gormquery.Query) error); ok {
		r0 = rf(ctx, queries...)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockRepository_Delete_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Delete'
type MockRepository_Delete_Call struct {
	*mock.Call
}

// Delete is a helper method to define mock.On call
//   - ctx context.Context
//   - queries ...gormquery.Query
func (_e *MockRepository_Expecter) Delete(ctx interface{}, queries ...interface{}) *MockRepository_Delete_Call {
	return &MockRepository_Delete_Call{Call: _e.mock.On("Delete",
		append([]interface{}{ctx}, queries...)...)}
}

func (_c *MockRepository_Delete_Call) Run(run func(ctx context.Context, queries ...gormquery.Query)) *MockRepository_Delete_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]gormquery.Query, len(args)-1)
		for i, a := range args[1:] {
			if a != nil {
				variadicArgs[i] = a.(gormquery.Query)
			}
		}
		run(args[0].(context.Context), variadicArgs...)
	})
	return _c
}

func (_c *MockRepository_Delete_Call) Return(_a0 error) *MockRepository_Delete_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_Delete_Call) RunAndReturn(run func(context.Context, ...gormquery.Query) error) *MockRepository_Delete_Call {
	_c.Call.Return(run)
	return _c
}

// DeleteByID provides a mock function with given fields: ctx, id
func (_m *MockRepository) DeleteByID(ctx context.Context, id uint64) error {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for DeleteByID")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, uint64) error); ok {
		r0 = rf(ctx, id)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockRepository_DeleteByID_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'DeleteByID'
type MockRepository_DeleteByID_Call struct {
	*mock.Call
}

// DeleteByID is a helper method to define mock.On call
//   - ctx context.Context
//   - id uint64
func (_e *MockRepository_Expecter) DeleteByID(ctx interface{}, id interface{}) *MockRepository_DeleteByID_Call {
	return &MockRepository_DeleteByID_Call{Call: _e.mock.On("DeleteByID", ctx, id)}
}

func (_c *MockRepository_DeleteByID_Call) Run(run func(ctx context.Context, id uint64)) *MockRepository_DeleteByID_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(uint64))
	})
	return _c
}

func (_c *MockRepository_DeleteByID_Call) Return(_a0 error) *MockRepository_DeleteByID_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_DeleteByID_Call) RunAndReturn(run func(context.Context, uint64) error) *MockRepository_DeleteByID_Call {
	_c.Call.Return(run)
	return _c
}

// Find provides a mock function with given fields: ctx, queries
func (_m *MockRepository) Find(ctx context.Context, queries ...gormquery.Query) (*[]entities.Brand, error) {
	_va := make([]interface{}, len(queries))
	for _i := range queries {
		_va[_i] = queries[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for Find")
	}

	var r0 *[]entities.Brand
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, ...gormquery.Query) (*[]entities.Brand, error)); ok {
		return rf(ctx, queries...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, ...gormquery.Query) *[]entities.Brand); ok {
		r0 = rf(ctx, queries...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*[]entities.Brand)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, ...gormquery.Query) error); ok {
		r1 = rf(ctx, queries...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_Find_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Find'
type MockRepository_Find_Call struct {
	*mock.Call
}

// Find is a helper method to define mock.On call
//   - ctx context.Context
//   - queries ...gormquery.Query
func (_e *MockRepository_Expecter) Find(ctx interface{}, queries ...interface{}) *MockRepository_Find_Call {
	return &MockRepository_Find_Call{Call: _e.mock.On("Find",
		append([]interface{}{ctx}, queries...)...)}
}

func (_c *MockRepository_Find_Call) Run(run func(ctx context.Context, queries ...gormquery.Query)) *MockRepository_Find_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]gormquery.Query, len(args)-1)
		for i, a := range args[1:] {
			if a != nil {
				variadicArgs[i] = a.(gormquery.Query)
			}
		}
		run(args[0].(context.Context), variadicArgs...)
	})
	return _c
}

func (_c *MockRepository_Find_Call) Return(_a0 *[]entities.Brand, _a1 error) *MockRepository_Find_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_Find_Call) RunAndReturn(run func(context.Context, ...gormquery.Query) (*[]entities.Brand, error)) *MockRepository_Find_Call {
	_c.Call.Return(run)
	return _c
}

// FindByID provides a mock function with given fields: ctx, id
func (_m *MockRepository) FindByID(ctx context.Context, id uint64) (*entities.Brand, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for FindByID")
	}

	var r0 *entities.Brand
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, uint64) (*entities.Brand, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, uint64) *entities.Brand); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*entities.Brand)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, uint64) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_FindByID_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'FindByID'
type MockRepository_FindByID_Call struct {
	*mock.Call
}

// FindByID is a helper method to define mock.On call
//   - ctx context.Context
//   - id uint64
func (_e *MockRepository_Expecter) FindByID(ctx interface{}, id interface{}) *MockRepository_FindByID_Call {
	return &MockRepository_FindByID_Call{Call: _e.mock.On("FindByID", ctx, id)}
}

func (_c *MockRepository_FindByID_Call) Run(run func(ctx context.Context, id uint64)) *MockRepository_FindByID_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(uint64))
	})
	return _c
}

func (_c *MockRepository_FindByID_Call) Return(_a0 *entities.Brand, _a1 error) *MockRepository_FindByID_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_FindByID_Call) RunAndReturn(run func(context.Context, uint64) (*entities.Brand, error)) *MockRepository_FindByID_Call {
	_c.Call.Return(run)
	return _c
}

// New provides a mock function with given fields: db
func (_m *MockRepository) New(db interface{}) (Repository, error) {
	ret := _m.Called(db)

	if len(ret) == 0 {
		panic("no return value specified for New")
	}

	var r0 Repository
	var r1 error
	if rf, ok := ret.Get(0).(func(interface{}) (Repository, error)); ok {
		return rf(db)
	}
	if rf, ok := ret.Get(0).(func(interface{}) Repository); ok {
		r0 = rf(db)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(Repository)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}) error); ok {
		r1 = rf(db)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_New_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'New'
type MockRepository_New_Call struct {
	*mock.Call
}

// New is a helper method to define mock.On call
//   - db interface{}
func (_e *MockRepository_Expecter) New(db interface{}) *MockRepository_New_Call {
	return &MockRepository_New_Call{Call: _e.mock.On("New", db)}
}

func (_c *MockRepository_New_Call) Run(run func(db interface{})) *MockRepository_New_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(interface{}))
	})
	return _c
}

func (_c *MockRepository_New_Call) Return(_a0 Repository, _a1 error) *MockRepository_New_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_New_Call) RunAndReturn(run func(interface{}) (Repository, error)) *MockRepository_New_Call {
	_c.Call.Return(run)
	return _c
}

// TranslateOrderField provides a mock function with given fields: input
func (_m *MockRepository) TranslateOrderField(input string) string {
	ret := _m.Called(input)

	if len(ret) == 0 {
		panic("no return value specified for TranslateOrderField")
	}

	var r0 string
	if rf, ok := ret.Get(0).(func(string) string); ok {
		r0 = rf(input)
	} else {
		r0 = ret.Get(0).(string)
	}

	return r0
}

// MockRepository_TranslateOrderField_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'TranslateOrderField'
type MockRepository_TranslateOrderField_Call struct {
	*mock.Call
}

// TranslateOrderField is a helper method to define mock.On call
//   - input string
func (_e *MockRepository_Expecter) TranslateOrderField(input interface{}) *MockRepository_TranslateOrderField_Call {
	return &MockRepository_TranslateOrderField_Call{Call: _e.mock.On("TranslateOrderField", input)}
}

func (_c *MockRepository_TranslateOrderField_Call) Run(run func(input string)) *MockRepository_TranslateOrderField_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(string))
	})
	return _c
}

func (_c *MockRepository_TranslateOrderField_Call) Return(output string) *MockRepository_TranslateOrderField_Call {
	_c.Call.Return(output)
	return _c
}

func (_c *MockRepository_TranslateOrderField_Call) RunAndReturn(run func(string) string) *MockRepository_TranslateOrderField_Call {
	_c.Call.Return(run)
	return _c
}

// Update provides a mock function with given fields: ctx, data
func (_m *MockRepository) Update(ctx context.Context, data *entities.Brand) error {
	ret := _m.Called(ctx, data)

	if len(ret) == 0 {
		panic("no return value specified for Update")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *entities.Brand) error); ok {
		r0 = rf(ctx, data)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockRepository_Update_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Update'
type MockRepository_Update_Call struct {
	*mock.Call
}

// Update is a helper method to define mock.On call
//   - ctx context.Context
//   - data *entities.Brand
func (_e *MockRepository_Expecter) Update(ctx interface{}, data interface{}) *MockRepository_Update_Call {
	return &MockRepository_Update_Call{Call: _e.mock.On("Update", ctx, data)}
}

func (_c *MockRepository_Update_Call) Run(run func(ctx context.Context, data *entities.Brand)) *MockRepository_Update_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*entities.Brand))
	})
	return _c
}

func (_c *MockRepository_Update_Call) Return(_a0 error) *MockRepository_Update_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_Update_Call) RunAndReturn(run func(context.Context, *entities.Brand) error) *MockRepository_Update_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockRepository creates a new instance of MockRepository. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockRepository(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockRepository {
	mock := &MockRepository{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
